
#
# CASA is a clustering service for AS1.
#
Class CASAAgent

CASAAgent public init { argv } {
	$self instvar prefops_ alg_ 

	array set ssd $argv
	set A [lindex $ssd(addrs) 1]	

	# a database and operations on preference reports
	set prefops_ [new Prefops/$ssd(prefops)]	

	# init clustering algorithm
	if { "$ssd(layer)" == "yes" } {
		set K [expr round($A / $ssd(L))]
		set alg_ [new GS/Kmeans $prefops_ $K]
	} else {
		set K $A
		set alg_ [new GR/Kmeans $prefops_ $K]		
	}

}

CASAAgent public recv_prefreport { addr data } {
	$self instvar prefops_ alg_

	array set ssd $data
	$prefops_ set_wts $addr $ssd(pref)
}

CASAAgent public recv_keepalive { addr data } {
	$self instvar prefops_ alg_

	
	
}

CASAAgent public get_clusterinfo { } {


	global default_mappings
	return [array get default_mappings]
}

