void JpegDecoder::blit(short* src, u_char* p, int stride, u_int* mask, int nc)
{
#ifdef notdef
	u_int src[32];/*XXX just testing*/
	bzero((char*)src, sizeof(src));
	((short*)src)[0] = blk[0];
	int m = mask[0];
	for (int i = 0; i < 32; ++i) {
		if (m & (1 << i))
			((short*)src)[i] = blk[i];
	}
#ifdef notdef
	m = mask[1];
	for (; i < 64; ++i) {
		if (m & (1 << i))
			((short*)src)[i] = blk[i];
	}
#endif
#endif

	idct((short*)src, mask, p, stride);/*XXX*/
#ifdef notdef

	u_int* bp = (u_int*)src;
	for (int i = 8; --i >= 0; ) {
		register int t, b;
		register u_int o;
#if BYTE_ORDER == LITTLE_ENDIAN
#define CRACK0(b) UCLIMIT((b << 16 >> 16) + 128)
#define CRACK1(b) UCLIMIT((b >> 16) + 128)
#define SPLICE_PIXEL(out, c, off) out |= (c << (24 - off))
#else
#define SPLICE_PIXEL(out, c, off) out |= (c << (off))
#define CRACK0(b) UCLIMIT((b >> 16) + 128)
#define CRACK1(b) UCLIMIT((b << 16 >> 16) + 128)
#endif
		b = bp[0];
		o = 0;
		SPLICE_PIXEL(o, CRACK0(b), 24);
		SPLICE_PIXEL(o, CRACK1(b), 16);

		b = bp[1];
		SPLICE_PIXEL(o, CRACK0(b), 8);
		SPLICE_PIXEL(o, CRACK1(b), 0);
		*(u_int*)p = o;

		b = bp[2];
		o = 0;
		SPLICE_PIXEL(o, CRACK0(b), 24);
		SPLICE_PIXEL(o, CRACK1(b), 16);

		b = bp[3];
		SPLICE_PIXEL(o, CRACK0(b), 8);
		SPLICE_PIXEL(o, CRACK1(b), 0);
		*(u_int*)(p + 4) = o;

		p += stride;
		bp += 4;
	}
#endif
}

